program NkVp;

uses Windows, Messages, NSys, NLib, NUtil, NForm, MainForm;

{$R *.RES}

function SendPath(Start: Integer): Boolean;
var
  wnd: HWnd;
  cd: TCopyDataStruct;
  buf: string;
  i: Integer;
begin
  wnd := FindWindow(PChar(string(TNkVpMainform.ClassName)), nil);
  if wnd = 0 then
  begin
    Result := False;
    Exit;
  end;
  SetForegroundWindow(wnd);
  cd.dwData := 0;
  buf := '';
  for i := Start to Argc-1 do
    buf := buf + '"' + Argv[i] + '" '; // XXX
  cd.cbData := Length(buf)+1; // +1: null terminator
  cd.lpData := PChar(buf);
  SendMessage(wnd, WM_COPYDATA, 0, LPARAM(@cd));
  Result := True;
end;

var
  Form: TNkVpMainForm;
  i, j: Integer;
  eflag: Boolean = False;
  fflag: Boolean = False;
begin
  AppName := 'NkVp';
  ProfDir := GetEnv('NKTOOLSPROF', '');
  if ProfDir = '' then
    ProfDir := DirName(AbsPath(Argv[0]))
  else
    ProfDir := JoinPath(ProfDir, Lower(AppName));

  with TOptParser.Create(Argc, Argv) do
    try
      while GetArg do
        case Flag of
          'e': eflag := True;
          'f': fflag := True;
        else
          ErrMsgBox(AppName, 'usage: nkvp [-ef] [file ...]');
          Exit;
        end;
      j := ArgInd;
    finally
      Free;
    end;

  if AlreadyRun(AppName) and (j < Argc) then
    if SendPath(j) then
      Exit;

  Form := TNkVpMainForm.CreateDefaultPos(AppName, 320, 240);
  try
    SetMainForm(Form);
    Form.ExitAtEnd := eflag;
    for i := j to Argc-1 do
      if IsDir(Argv[i]) then
        Form.Playlist.AddDir(Argv[i])
      else
        Form.Playlist.Add(Argv[i]);
    Form.Show;
    Form.LoadFromPlaylist(0, True);
    if Form.Player.Loaded and fflag then
      Form.cmFullScreen;
    ExitCode := MessageLoop;
  finally
    Form.Free;
  end;
end.
